package ru.narfu.kozalo.des

import kotlin.math.floor


fun ByteArray.bisect(): Pair<ByteArray, ByteArray> {
    assert(this.size % 2 == 0)
    val middle = this.size / 2
    return Pair(this.copyOfRange(0, middle), this.copyOfRange(middle, this.size))
}


fun <T> List<T>.bisect(): Pair<List<T>, List<T>> {
    assert(this.size % 2 == 0)
    val middle = this.size / 2
    return Pair(this.take(middle), this.takeLast(middle))
}


fun ByteArray.bisectOdd(): Pair<ByteArray, ByteArray> {
    assert(this.size % 2 != 0)
    val middleIndex = floor(this.size / 2.0).toInt()

    val firstHalf: MutableList<Byte> = this.take(middleIndex).toMutableList()
    val lastHalf: MutableList<Byte> = this.takeLast(middleIndex).toMutableList()
    val middleByte: Int = this[middleIndex].toInt()
    val firstAdditionalByte: Int = (0b11110000 and middleByte)
    val secondAdditionalByte: Int = (0b00001111 and middleByte)

    firstHalf.add(firstAdditionalByte.toByte())
    lastHalf.add(0, secondAdditionalByte.toByte())
    return Pair(firstHalf.toByteArray(), lastHalf.toByteArray())
}
