package ru.narfu.kozalo.des

import kotlin.system.exitProcess


fun main(args: Array<String>) {
    val (sourceString, keyString) = if (args.size >= 2) {
        Pair(args[0], args[1])
    } else {
        print("Input string to encrypt: ")
        val arg1 = readLine()
        print("Input key: ")
        val arg2 = readLine()
        Pair(arg1!!, arg2!!)
    }

    if (sourceString.length != 8 || keyString.length != 8) {
        println("Both a string to encrypt and a key must be 8 characters long!")
        exitProcess(1)
    }

    computeAnswers(sourceString, keyString)
}


private fun computeAnswers(sourceString: String, keyString: String) {
    val bytes = splitString(sourceString)[0]
    val permutated = initialPermutation(bytes)
    print("Initial permutation: ")
    permutated.printElements()
    println()

    val (l0, r0) = permutated.bisect()
    print("L(0): ")
    l0.printElements()
    print("R(0): ")
    r0.printElements()
    println()

    print("B: ")
    val permutatedKey = keyPermutation(keyString.toByteArray())
    permutatedKey.printElements()
    println()

    val (c0, d0) = permutatedKey.bisectOdd()
    val c0Str = c0.reduceToString().dropLast(4)
    val d0Str = d0.reduceToString().drop(4)
    print("C(0): $c0Str\nD(0): $d0Str\n\n")

    print("Input i: ")
    val i1 = Integer.parseInt(readLine())
    val cI = c16ShlList(c0)[i1 - 1]
    print("C(i): $cI\n\nInput i: ")
    val i2 = Integer.parseInt(readLine())
    val dI = c16ShlList(d0 shl 4)[i2 - 1]
    println("D(i): $dI")
}
