package ru.narfu.kozalo.des


fun initialPermutation(byteArray: ByteArray): ByteArray {
    val intArray = byteArray.map { it.toInt() }
    val a = intArray.map { it and 0b01000000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (6 - i)) }
    val b = intArray.map { it and 0b00010000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (4 - i)) }
    val c = intArray.map { it and 0b00000100 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (2 - i)) }
    val d = intArray.map { it and 0b00000001 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh -i) }
    val e = intArray.map { it and 0b10000000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (7 - i)) }
    val f = intArray.map { it and 0b00100000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (5 - i)) }
    val g = intArray.map { it and 0b00001000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (3 - i)) }
    val h = intArray.map { it and 0b00000010 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (1 - i)) }
    return listOf(a, b, c, d, e, f, g, h).map { it.toByte() }.toByteArray()
}


fun keyPermutation(byteArray: ByteArray): ByteArray {
    val intArray = byteArray.map { it.toInt() }
    val a = intArray.map { it and 0b10000000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (7 - i)) }
    val b = intArray.map { it and 0b01000000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (6 - i)) }
    val c = intArray.map { it and 0b00100000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (5 - i)) }

    val (l1, l2) = intArray.bisect()
    val d1 = l1.map { it and 0b00010000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (4 - i)) }
    val d2 = l2.map { it and 0b00010000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (4 - i)) }
    val e = intArray.map { it and 0b00000010 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (1 - i)) }
    val f = intArray.map { it and 0b00000100 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (2 - i)) }
    val g = intArray.map { it and 0b00001000 }.foldRightIndexed(0) { i, byte, acc -> acc or (byte sh (3 - i)) }

    val d2e1 = (d2 shl 4) or ((e and 0b11110000) shr 4)
    val e2f1 = ((e and 0b00001111) shl 4) or ((f and 0b11110000) shr 4)
    val f2g1 = ((f and 0b00001111) shl 4) or ((g and 0b11110000) shr 4)
    val g2d1 = ((g and 0b00001111) shl 4) or d1

    return listOf(a, b, c, d2e1, e2f1, f2g1, g2d1).map { it.toByte() }.toByteArray()
}


fun c16ShlList(byteArray: ByteArray): List<String> {
    var newByteArray = byteArray.clone()
    var cumulativeOffset = 0
    return arrayOf(1, 1, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 1).map { offset ->
        cumulativeOffset += offset
        newByteArray = newByteArray shl offset
        val newByteString = newByteArray.map { it.bin() }.reduce { acc, s -> acc + s }
        val replacementIndex = newByteString.length - cumulativeOffset
        newByteString.replaceRange(replacementIndex - 4, replacementIndex, "")
    }
}
