package ru.narfu.kozalo.des


fun Int.bin() = "%8s".format(Integer.toBinaryString(this and 0xFF)).replace(' ', '0')

fun Byte.bin() = this.toInt().bin()


fun ByteArray.reduceToString() = this.map { it.bin() }.reduce { acc, s -> acc + s }

fun ByteArray.printElements() {
    println(this.reduceToString())
}


fun splitString(s: String): List<ByteArray> {
    return s.chunked(8)
            .map { it.toByteArray() }
            .map { byteArray ->
                val diff = 8 - byteArray.size
                if (diff > 0) {
                    byteArray + ByteArray(diff)
                } else {
                    byteArray
                }
            }
}
